package ru.dbotthepony.mc.otm.client.screen.panels.buttons

import net.minecraft.client.gui.screens.Screen
import ru.dbotthepony.mc.otm.client.minecraft
import ru.dbotthepony.mc.otm.client.screen.panels.EditablePanel
import ru.dbotthepony.mc.otm.menu.widget.BooleanPlayerInputWidget

open class CheckBoxInputPanel<out S : Screen> @JvmOverloads constructor(
	screen: S,
	parent: EditablePanel<*>?,
	val widget: BooleanPlayerInputWidget,
	x: Float = 0f,
	y: Float = 0f,
	width: Float = REGULAR_DIMENSIONS + 120f,
	height: Float = REGULAR_DIMENSIONS
) : CheckBoxPanel<S>(screen, parent, x, y, width, height) {
	override var checked: Boolean
		get() = widget.value
		set(value) {}

	override var isDisabled: Boolean
		get() = !widget.ignoreSpectators || minecraft.player?.isSpectator == true
		set(value) {}

	override fun onClick() {
		widget.userInput(!checked, minecraft.player)
	}
}
